Code

t9143: do not fail if Compress::Zlib is missing
[git.git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [<mbox>|<Maildir>...]
9 git am [options] (--resolved | --skip | --abort)
10 --
11 i,interactive   run interactively
12 b,binary*       (historical option -- no-op)
13 3,3way          allow fall back on 3way merging if needed
14 q,quiet         be quiet
15 s,signoff       add a Signed-off-by line to the commit message
16 u,utf8          recode into utf8 (default)
17 k,keep          pass -k flag to git-mailinfo
18 whitespace=     pass it through git-apply
19 directory=      pass it through git-apply
20 C=              pass it through git-apply
21 p=              pass it through git-apply
22 patch-format=   format the patch(es) are in
23 reject          pass it through git-apply
24 resolvemsg=     override error message when patch failure occurs
25 r,resolved      to be used after a patch failure
26 skip            skip the current patch
27 abort           restore the original branch and abort the patching operation.
28 committer-date-is-author-date    lie about committer date
29 ignore-date     use current timestamp for author date
30 rebasing*       (internal use for git-rebase)"
32 . git-sh-setup
33 prefix=$(git rev-parse --show-prefix)
34 set_reflog_action am
35 require_work_tree
36 cd_to_toplevel
38 git var GIT_COMMITTER_IDENT >/dev/null ||
39         die "You need to set your committer info first"
41 if git rev-parse --verify -q HEAD >/dev/null
42 then
43         HAS_HEAD=yes
44 else
45         HAS_HEAD=
46 fi
48 sq () {
49         git rev-parse --sq-quote "$@"
50 }
52 stop_here () {
53     echo "$1" >"$dotest/next"
54     exit 1
55 }
57 stop_here_user_resolve () {
58     if [ -n "$resolvemsg" ]; then
59             printf '%s\n' "$resolvemsg"
60             stop_here $1
61     fi
62     cmdline="git am"
63     if test '' != "$interactive"
64     then
65         cmdline="$cmdline -i"
66     fi
67     if test '' != "$threeway"
68     then
69         cmdline="$cmdline -3"
70     fi
71     echo "When you have resolved this problem run \"$cmdline --resolved\"."
72     echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
73     echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
75     stop_here $1
76 }
78 go_next () {
79         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
80                 "$dotest/patch" "$dotest/info"
81         echo "$next" >"$dotest/next"
82         this=$next
83 }
85 cannot_fallback () {
86         echo "$1"
87         echo "Cannot fall back to three-way merge."
88         exit 1
89 }
91 fall_back_3way () {
92     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
94     rm -fr "$dotest"/patch-merge-*
95     mkdir "$dotest/patch-merge-tmp-dir"
97     # First see if the patch records the index info that we can use.
98     git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
99         "$dotest/patch" &&
100     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
101     git write-tree >"$dotest/patch-merge-base+" ||
102     cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
104     say Using index info to reconstruct a base tree...
105     if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
106         git apply --cached <"$dotest/patch"
107     then
108         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
109         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
110     else
111         cannot_fallback "Did you hand edit your patch?
112 It does not apply to blobs recorded in its index."
113     fi
115     test -f "$dotest/patch-merge-index" &&
116     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
117     orig_tree=$(cat "$dotest/patch-merge-base") &&
118     rm -fr "$dotest"/patch-merge-* || exit 1
120     say Falling back to patching base and 3-way merge...
122     # This is not so wrong.  Depending on which base we picked,
123     # orig_tree may be wildly different from ours, but his_tree
124     # has the same set of wildly different changes in parts the
125     # patch did not touch, so recursive ends up canceling them,
126     # saying that we reverted all those changes.
128     eval GITHEAD_$his_tree='"$FIRSTLINE"'
129     export GITHEAD_$his_tree
130     if test -n "$GIT_QUIET"
131     then
132             export GIT_MERGE_VERBOSITY=0
133     fi
134     git-merge-recursive $orig_tree -- HEAD $his_tree || {
135             git rerere
136             echo Failed to merge in the changes.
137             exit 1
138     }
139     unset GITHEAD_$his_tree
142 clean_abort () {
143         test $# = 0 || echo >&2 "$@"
144         rm -fr "$dotest"
145         exit 1
148 patch_format=
150 check_patch_format () {
151         # early return if patch_format was set from the command line
152         if test -n "$patch_format"
153         then
154                 return 0
155         fi
157         # we default to mbox format if input is from stdin and for
158         # directories
159         if test $# = 0 || test "x$1" = "x-" || test -d "$1"
160         then
161                 patch_format=mbox
162                 return 0
163         fi
165         # otherwise, check the first few lines of the first patch to try
166         # to detect its format
167         {
168                 read l1
169                 read l2
170                 read l3
171                 case "$l1" in
172                 "From "* | "From: "*)
173                         patch_format=mbox
174                         ;;
175                 '# This series applies on GIT commit'*)
176                         patch_format=stgit-series
177                         ;;
178                 "# HG changeset patch")
179                         patch_format=hg
180                         ;;
181                 *)
182                         # if the second line is empty and the third is
183                         # a From, Author or Date entry, this is very
184                         # likely an StGIT patch
185                         case "$l2,$l3" in
186                         ,"From: "* | ,"Author: "* | ,"Date: "*)
187                                 patch_format=stgit
188                                 ;;
189                         *)
190                                 ;;
191                         esac
192                         ;;
193                 esac
194         } < "$1" || clean_abort
197 split_patches () {
198         case "$patch_format" in
199         mbox)
200                 git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||
201                 clean_abort
202                 ;;
203         stgit-series)
204                 if test $# -ne 1
205                 then
206                         clean_abort "Only one StGIT patch series can be applied at once"
207                 fi
208                 series_dir=`dirname "$1"`
209                 series_file="$1"
210                 shift
211                 {
212                         set x
213                         while read filename
214                         do
215                                 set "$@" "$series_dir/$filename"
216                         done
217                         # remove the safety x
218                         shift
219                         # remove the arg coming from the first-line comment
220                         shift
221                 } < "$series_file" || clean_abort
222                 # set the patch format appropriately
223                 patch_format=stgit
224                 # now handle the actual StGIT patches
225                 split_patches "$@"
226                 ;;
227         stgit)
228                 this=0
229                 for stgit in "$@"
230                 do
231                         this=`expr "$this" + 1`
232                         msgnum=`printf "%0${prec}d" $this`
233                         # Perl version of StGIT parse_patch. The first nonemptyline
234                         # not starting with Author, From or Date is the
235                         # subject, and the body starts with the next nonempty
236                         # line not starting with Author, From or Date
237                         perl -ne 'BEGIN { $subject = 0 }
238                                 if ($subject > 1) { print ; }
239                                 elsif (/^\s+$/) { next ; }
240                                 elsif (/^Author:/) { print s/Author/From/ ; }
241                                 elsif (/^(From|Date)/) { print ; }
242                                 elsif ($subject) {
243                                         $subject = 2 ;
244                                         print "\n" ;
245                                         print ;
246                                 } else {
247                                         print "Subject: ", $_ ;
248                                         $subject = 1;
249                                 }
250                         ' < "$stgit" > "$dotest/$msgnum" || clean_abort
251                 done
252                 echo "$this" > "$dotest/last"
253                 this=
254                 msgnum=
255                 ;;
256         *)
257                 clean_abort "Patch format $patch_format is not supported."
258                 ;;
259         esac
262 prec=4
263 dotest="$GIT_DIR/rebase-apply"
264 sign= utf8=t keep= skip= interactive= resolved= rebasing= abort=
265 resolvemsg= resume=
266 git_apply_opt=
267 committer_date_is_author_date=
268 ignore_date=
270 while test $# != 0
271 do
272         case "$1" in
273         -i|--interactive)
274                 interactive=t ;;
275         -b|--binary)
276                 : ;;
277         -3|--3way)
278                 threeway=t ;;
279         -s|--signoff)
280                 sign=t ;;
281         -u|--utf8)
282                 utf8=t ;; # this is now default
283         --no-utf8)
284                 utf8= ;;
285         -k|--keep)
286                 keep=t ;;
287         -r|--resolved)
288                 resolved=t ;;
289         --skip)
290                 skip=t ;;
291         --abort)
292                 abort=t ;;
293         --rebasing)
294                 rebasing=t threeway=t keep=t ;;
295         -d|--dotest)
296                 die "-d option is no longer supported.  Do not use."
297                 ;;
298         --resolvemsg)
299                 shift; resolvemsg=$1 ;;
300         --whitespace|--directory)
301                 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
302         -C|-p)
303                 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
304         --patch-format)
305                 shift ; patch_format="$1" ;;
306         --reject)
307                 git_apply_opt="$git_apply_opt $1" ;;
308         --committer-date-is-author-date)
309                 committer_date_is_author_date=t ;;
310         --ignore-date)
311                 ignore_date=t ;;
312         -q|--quiet)
313                 GIT_QUIET=t ;;
314         --)
315                 shift; break ;;
316         *)
317                 usage ;;
318         esac
319         shift
320 done
322 # If the dotest directory exists, but we have finished applying all the
323 # patches in them, clear it out.
324 if test -d "$dotest" &&
325    last=$(cat "$dotest/last") &&
326    next=$(cat "$dotest/next") &&
327    test $# != 0 &&
328    test "$next" -gt "$last"
329 then
330    rm -fr "$dotest"
331 fi
333 if test -d "$dotest"
334 then
335         case "$#,$skip$resolved$abort" in
336         0,*t*)
337                 # Explicit resume command and we do not have file, so
338                 # we are happy.
339                 : ;;
340         0,)
341                 # No file input but without resume parameters; catch
342                 # user error to feed us a patch from standard input
343                 # when there is already $dotest.  This is somewhat
344                 # unreliable -- stdin could be /dev/null for example
345                 # and the caller did not intend to feed us a patch but
346                 # wanted to continue unattended.
347                 test -t 0
348                 ;;
349         *)
350                 false
351                 ;;
352         esac ||
353         die "previous rebase directory $dotest still exists but mbox given."
354         resume=yes
356         case "$skip,$abort" in
357         t,t)
358                 die "Please make up your mind. --skip or --abort?"
359                 ;;
360         t,)
361                 git rerere clear
362                 git read-tree --reset -u HEAD HEAD
363                 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
364                 git reset HEAD
365                 git update-ref ORIG_HEAD $orig_head
366                 ;;
367         ,t)
368                 if test -f "$dotest/rebasing"
369                 then
370                         exec git rebase --abort
371                 fi
372                 git rerere clear
373                 test -f "$dotest/dirtyindex" || {
374                         git read-tree --reset -u HEAD ORIG_HEAD
375                         git reset ORIG_HEAD
376                 }
377                 rm -fr "$dotest"
378                 exit ;;
379         esac
380         rm -f "$dotest/dirtyindex"
381 else
382         # Make sure we are not given --skip, --resolved, nor --abort
383         test "$skip$resolved$abort" = "" ||
384                 die "Resolve operation not in progress, we are not resuming."
386         # Start afresh.
387         mkdir -p "$dotest" || exit
389         if test -n "$prefix" && test $# != 0
390         then
391                 first=t
392                 for arg
393                 do
394                         test -n "$first" && {
395                                 set x
396                                 first=
397                         }
398                         case "$arg" in
399                         /*)
400                                 set "$@" "$arg" ;;
401                         *)
402                                 set "$@" "$prefix$arg" ;;
403                         esac
404                 done
405                 shift
406         fi
408         check_patch_format "$@"
410         split_patches "$@"
412         # -s, -u, -k, --whitespace, -3, -C, -q and -p flags are kept
413         # for the resuming session after a patch failure.
414         # -i can and must be given when resuming.
415         echo " $git_apply_opt" >"$dotest/apply-opt"
416         echo "$threeway" >"$dotest/threeway"
417         echo "$sign" >"$dotest/sign"
418         echo "$utf8" >"$dotest/utf8"
419         echo "$keep" >"$dotest/keep"
420         echo "$GIT_QUIET" >"$dotest/quiet"
421         echo 1 >"$dotest/next"
422         if test -n "$rebasing"
423         then
424                 : >"$dotest/rebasing"
425         else
426                 : >"$dotest/applying"
427                 if test -n "$HAS_HEAD"
428                 then
429                         git update-ref ORIG_HEAD HEAD
430                 else
431                         git update-ref -d ORIG_HEAD >/dev/null 2>&1
432                 fi
433         fi
434 fi
436 case "$resolved" in
437 '')
438         case "$HAS_HEAD" in
439         '')
440                 files=$(git ls-files) ;;
441         ?*)
442                 files=$(git diff-index --cached --name-only HEAD --) ;;
443         esac || exit
444         if test "$files"
445         then
446                 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
447                 die "Dirty index: cannot apply patches (dirty: $files)"
448         fi
449 esac
451 if test "$(cat "$dotest/utf8")" = t
452 then
453         utf8=-u
454 else
455         utf8=-n
456 fi
457 if test "$(cat "$dotest/keep")" = t
458 then
459         keep=-k
460 fi
461 if test "$(cat "$dotest/quiet")" = t
462 then
463         GIT_QUIET=t
464 fi
465 if test "$(cat "$dotest/threeway")" = t
466 then
467         threeway=t
468 fi
469 git_apply_opt=$(cat "$dotest/apply-opt")
470 if test "$(cat "$dotest/sign")" = t
471 then
472         SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
473                         s/>.*/>/
474                         s/^/Signed-off-by: /'
475                 `
476 else
477         SIGNOFF=
478 fi
480 last=`cat "$dotest/last"`
481 this=`cat "$dotest/next"`
482 if test "$skip" = t
483 then
484         this=`expr "$this" + 1`
485         resume=
486 fi
488 if test "$this" -gt "$last"
489 then
490         say Nothing to do.
491         rm -fr "$dotest"
492         exit
493 fi
495 while test "$this" -le "$last"
496 do
497         msgnum=`printf "%0${prec}d" $this`
498         next=`expr "$this" + 1`
499         test -f "$dotest/$msgnum" || {
500                 resume=
501                 go_next
502                 continue
503         }
505         # If we are not resuming, parse and extract the patch information
506         # into separate files:
507         #  - info records the authorship and title
508         #  - msg is the rest of commit log message
509         #  - patch is the patch body.
510         #
511         # When we are resuming, these files are either already prepared
512         # by the user, or the user can tell us to do so by --resolved flag.
513         case "$resume" in
514         '')
515                 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
516                         <"$dotest/$msgnum" >"$dotest/info" ||
517                         stop_here $this
519                 # skip pine's internal folder data
520                 grep '^Author: Mail System Internal Data$' \
521                         <"$dotest"/info >/dev/null &&
522                         go_next && continue
524                 test -s "$dotest/patch" || {
525                         echo "Patch is empty.  Was it split wrong?"
526                         stop_here $this
527                 }
528                 if test -f "$dotest/rebasing" &&
529                         commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
530                                 -e q "$dotest/$msgnum") &&
531                         test "$(git cat-file -t "$commit")" = commit
532                 then
533                         git cat-file commit "$commit" |
534                         sed -e '1,/^$/d' >"$dotest/msg-clean"
535                 else
536                         SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
537                         case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
539                         (printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
540                                 git stripspace > "$dotest/msg-clean"
541                 fi
542                 ;;
543         esac
545         GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
546         GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
547         GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
549         if test -z "$GIT_AUTHOR_EMAIL"
550         then
551                 echo "Patch does not have a valid e-mail address."
552                 stop_here $this
553         fi
555         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
557         case "$resume" in
558         '')
559             if test '' != "$SIGNOFF"
560             then
561                 LAST_SIGNED_OFF_BY=`
562                     sed -ne '/^Signed-off-by: /p' \
563                     "$dotest/msg-clean" |
564                     sed -ne '$p'
565                 `
566                 ADD_SIGNOFF=`
567                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
568                     test '' = "$LAST_SIGNED_OFF_BY" && echo
569                     echo "$SIGNOFF"
570                 }`
571             else
572                 ADD_SIGNOFF=
573             fi
574             {
575                 if test -s "$dotest/msg-clean"
576                 then
577                         cat "$dotest/msg-clean"
578                 fi
579                 if test '' != "$ADD_SIGNOFF"
580                 then
581                         echo "$ADD_SIGNOFF"
582                 fi
583             } >"$dotest/final-commit"
584             ;;
585         *)
586                 case "$resolved$interactive" in
587                 tt)
588                         # This is used only for interactive view option.
589                         git diff-index -p --cached HEAD -- >"$dotest/patch"
590                         ;;
591                 esac
592         esac
594         resume=
595         if test "$interactive" = t
596         then
597             test -t 0 ||
598             die "cannot be interactive without stdin connected to a terminal."
599             action=again
600             while test "$action" = again
601             do
602                 echo "Commit Body is:"
603                 echo "--------------------------"
604                 cat "$dotest/final-commit"
605                 echo "--------------------------"
606                 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
607                 read reply
608                 case "$reply" in
609                 [yY]*) action=yes ;;
610                 [aA]*) action=yes interactive= ;;
611                 [nN]*) action=skip ;;
612                 [eE]*) git_editor "$dotest/final-commit"
613                        action=again ;;
614                 [vV]*) action=again
615                        LESS=-S ${PAGER:-less} "$dotest/patch" ;;
616                 *)     action=again ;;
617                 esac
618             done
619         else
620             action=yes
621         fi
622         FIRSTLINE=$(sed 1q "$dotest/final-commit")
624         if test $action = skip
625         then
626                 go_next
627                 continue
628         fi
630         if test -x "$GIT_DIR"/hooks/applypatch-msg
631         then
632                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
633                 stop_here $this
634         fi
636         say "Applying: $FIRSTLINE"
638         case "$resolved" in
639         '')
640                 # When we are allowed to fall back to 3-way later, don't give
641                 # false errors during the initial attempt.
642                 squelch=
643                 if test "$threeway" = t
644                 then
645                         squelch='>/dev/null 2>&1 '
646                 fi
647                 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
648                 apply_status=$?
649                 ;;
650         t)
651                 # Resolved means the user did all the hard work, and
652                 # we do not have to do any patch application.  Just
653                 # trust what the user has in the index file and the
654                 # working tree.
655                 resolved=
656                 git diff-index --quiet --cached HEAD -- && {
657                         echo "No changes - did you forget to use 'git add'?"
658                         stop_here_user_resolve $this
659                 }
660                 unmerged=$(git ls-files -u)
661                 if test -n "$unmerged"
662                 then
663                         echo "You still have unmerged paths in your index"
664                         echo "did you forget to use 'git add'?"
665                         stop_here_user_resolve $this
666                 fi
667                 apply_status=0
668                 git rerere
669                 ;;
670         esac
672         if test $apply_status = 1 && test "$threeway" = t
673         then
674                 if (fall_back_3way)
675                 then
676                     # Applying the patch to an earlier tree and merging the
677                     # result may have produced the same tree as ours.
678                     git diff-index --quiet --cached HEAD -- && {
679                         say No changes -- Patch already applied.
680                         go_next
681                         continue
682                     }
683                     # clear apply_status -- we have successfully merged.
684                     apply_status=0
685                 fi
686         fi
687         if test $apply_status != 0
688         then
689                 printf 'Patch failed at %s %s\n' "$msgnum" "$FIRSTLINE"
690                 stop_here_user_resolve $this
691         fi
693         if test -x "$GIT_DIR"/hooks/pre-applypatch
694         then
695                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
696         fi
698         tree=$(git write-tree) &&
699         commit=$(
700                 if test -n "$ignore_date"
701                 then
702                         GIT_AUTHOR_DATE=
703                 fi
704                 parent=$(git rev-parse --verify -q HEAD) ||
705                 say >&2 "applying to an empty history"
707                 if test -n "$committer_date_is_author_date"
708                 then
709                         GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
710                         export GIT_COMMITTER_DATE
711                 fi &&
712                 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
713         ) &&
714         git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
715         stop_here $this
717         if test -x "$GIT_DIR"/hooks/post-applypatch
718         then
719                 "$GIT_DIR"/hooks/post-applypatch
720         fi
722         go_next
723 done
725 git gc --auto
727 rm -fr "$dotest"